<!DOCTYPE html>
<html lang="fr">

<head>
    <meta charset="utf-8" />
    <title>Atelier 04 - Les applications</title>
    <meta name="description" content="" />
    <meta name="robots" content="noindex">
    <meta name="author" content="Joris Navarro" />
    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
    <link rel="stylesheet" href="../src/reveal.js/css/reveal.css" />
    <link rel="stylesheet" href="../src/reveal.js/css/theme/league.css" id="theme" />
    <link rel="stylesheet" href="../src/reveal.js/lib/css/highlight/railscasts.css" />
    <!-- <link rel="stylesheet" href="../src/reveal.js/lib/css/highlight/github.css"> -->
    <link rel="stylesheet" href="../src/custom/style.css" />
    <script>
        document.write(
            '<link rel="stylesheet" href="../src/reveal.js/css/print/' +
            (window.location.search.match(/print-pdf/gi) ? "pdf" : "paper") +
            '.css" type="text/css" media="print">'
        );
    </script>
    <!--[if lt IE 9]>
      <script src="../src/reveal.js/lib/js/html5shiv.js"></script>
    <![endif]-->

    <!-- Code steps start -->
    <link rel="stylesheet" href="../src/code-steps/prism-tomorrow.css" />
    <link rel="stylesheet" href="../src/code-steps/style.css" />
    <!-- Code steps end -->
</head>

<body>
    <div class="reveal">
        <div id="pagination"></div>
        <div class="slides">
            <section data-background-image="img/IMG_20220921_150653.jpg">
                <h1>Les P'tits génies</h1>
            </section>

            <section>
                <h2>Atelier 3 - Les applications</h2>
                <!-- summary -->
            </section>


            <!-- chapters -->
            <!-- chapter 1 -->
            <section>
                <section data-background-image="img/fotis-fotopoulos-DuHKoV44prg-unsplash.jpg">
                    <h2>Les programmes informatiques</h2>
                    <small class="caption">Image Fotis Fotopoulos</small>
                </section>

                <section data-background-image="img/florian-olivo-JNz9bQD3Oio-unsplash.jpg">
                    <div>
                        <p class="strong" style="font-size: larger">
                            Un programme informatique est un ensemble d'opérations destinées à être exécutées par un ordinateur.
                        </p>
                        <small><a href="https://fr.wikipedia.org/wiki/Programme_informatique">Wikipedia</a></small></div>

                    <div class="fragment">
                        <p style="font-size: larger">
                            Un programme fait généralement partie d'un logiciel, destiné à fournir un service informatique
                        </p>
                        <small><a href="https://fr.wikipedia.org/wiki/Programme_informatique">Wikipedia</a></small></div>
                    <small class="caption">Image Florian Olivo</small>
                </section>

                <section>
                    <div>
                        <p class="strong" style="font-size: larger">
                            Les programmes informatiques sont concernés par le droit d'auteur et font l'objet d'une législation proche des œuvres artistiques.
                        </p>
                        <small><a href="https://fr.wikipedia.org/wiki/Programme_informatique">Wikipedia</a></small></div>
                </section>

                <section>
                    <H3><a href="https://fr.wikipedia.org/wiki/Licence_de_logiciel">Les licences de logiciel</a></H3>
                    <ul>
                        <li>Contrat -> CLUF</li>
                        <li>Utilisation</li>
                        <li>Modification</li>
                    </ul>
                    <aside class="notes">
                        Contrat de licence utilisateur final
                    </aside>
                </section>
                <section data-background-image="img/Classification_des_licences.svg" data-background-size="contain">

                </section>
                <section>
                    <ul>
                        <li>Licence fixe</li>
                        <li>Licence nominative</li>
                        <li>Licence flottante</li>
                        <li>Shareware</li>
                        <li>Licence libre <br>
                            <ul class="linone">
                                <li>utilisation</li>
                                <li>etude</li>
                                <li>modification</li>
                                <li>redistribution</li>
                            </ul>
                        </li>
                    </ul>
                </section>

                <section>
                    <div>
                        <h2>Taille d'un programme</h2>
                        <ul>
                            <li>microprogrammes</li>
                            <li>programmes embarqués</li>
                            <li>programmes systèmes</li>
                            <li>programmes applicatifs</li>
                            <li>logiciels</li>
                            <li>composants logiciels</li>
                        </ul>
                    </div>
                </section>

                <section>
                    <h2>Principe d'exécution d'un programme</h2>
                    <ul>
                        <li>charge les instructions en mémoire</li>
                        <li>mets des données en mémoire</li>
                        <li>Instructions exécutées par le processeur</li>
                        <li>Il s'appuie sur la mémoire (pile)</li>
                        <li>Intéragit avec les entrées/sorties</li>
                    </ul>
                </section>


                <section>
                    <h3>Principe d'exécution d'un programme</h3>
                    <ul>
                        <li>> 1 milliards d'opérations par seconde</li>
                        <li> => opérations sur 64 bits <small>(2<sup>64</sup> - 1 = 18 446 744 073 709 552 000)</small></li>
                        <li>limités par la vitesse d'échange des data (RAM et HD)</li>
                        <li>OS nécessite environ 10 millions d'instructions</li>
                    </ul>
                </section>

                <section>
                    <pre><code class="assembler" style="max-height: 900px; min-width: 1300px; margin-left:-200px;" >
section .bss                                    ; Section des variables non-initialisees
        Buffer:   resb 64                       ; Reservation de 64 blocs (octets ?) memoire pour la variable où sera stockee l'entree de l'utilisateur
        BufferSize:         equ $-Buffer        ; taille de cette variable

section .text                                   ; Section du code source
        global _start

 _start:                                        ; Entree du programme

        mov eax, 3                              ; Appel de sys_read
        mov ebx, 0                              ; Entree standard STDIN
        mov ecx, Buffer                         ; Stockage de l'entree de l'utilisateur
        mov edx, BufferSize                     ; Taille maximale
        int 80h                                 ; Interruption du kernel

        mov eax, 4                              ; Appel de sys_write
        mov ebx, 1                              ; Sortie standard STDOUT
        mov ecx, Buffer                         ; Chaine à afficher
        mov edx, BufferSize                     ; Taille de la chaine
        int 80h                                 ; Interruption du kernel

        mov eax, 1                              ; Appel de sys_exit
        mov ebx, 0                              ; Code de retour
        int 80h                                 ; Interruption du kernel
                    </code></pre>
                </section>

                <section data-background-image="img/krishna-pandey-KNZHyTpre18-unsplash.jpg">
                    <div>
                        <p>Les programmes sont créés à partir de code source</p>
                    </div>
                    <small class="caption"> Image krishna-pandey</small>
                    <pre><code data-trim data-noescape>
                            public class Program
                            {
                                public void Main(string[] args)
                                {
                                    WhereClause1.QuerySyntaxExample();
                            
                                    // Add the method syntax as an example.
                                    WhereClause1.MethodSyntaxExample();
                                }
                            }
                        </code></pre>
                </section>

                <section data-background-image="img/markus-spiske-VO5w2Ida70s-unsplash.jpg">
                    <div>
                        <h2>Sources != Programme *</h2>
                    </div>
                    <small class="caption"> Image Markus Spiske</small>
                </section>

                <section>
                    <ul>
                        <li><span class="highlight">Source</span> = texte qui détaille les instructions dans un language de programmation<br></li>
                        <li><span class="highlight">Programme</span> = code machine créé à partir de la compilation du code source</li>
                    </ul>
                </section>


                <section>
                    <img src="img/8etapes.png" />
                    <img src="img/compilation.jpg" />
                </section>

                <section data-background-image="img/175843.png" data-background-size="contain">
                    <small class="caption"> Image OpenClassroom</small>
                </section>

                <section>
                    <h2>Simulons un programme</h2>
                    <ul>
                        <li class="fragment">but : Afficher Bonjour sur l'écran</li>
                        <li class="fragment">contexte : Vous êtes les éléments de l'ordinateur <br>
                            <ul>
                                <li>Carte mère = pièce</li>
                                <li>Écran = tableau</li>
                                <li>Carte graphique = ?</li>
                                <li>Mémoire (registre) = ?</li>
                                <li>CPU = ?</li>
                                <li>Disque = ?</li>
                                <li>OS = ?</li>
                                <li>Utilisateur = ?</li>
                            </ul>
                        </li>

                    </ul>
                </section>

                <section>
                    <h2>Simulons un programme #1</h2>
                    <ul>
                        <li class="fragment">Source: <br>
                            <pre class="code" style="margin: 0; box-shadow: none;"> <code>
class Program
{
    static void Main()
    {
        Console.WriteLine("Bonjour");
        return 0;
    }                                       
}                              </code>                                 
                            </pre>
                        </li>
                        <li class="fragment">Code "machine": <br>
                            <pre class="code csharp" style="margin: 0; box-shadow: none; overflow: hidden;"> <code>
0101 1010      
1010 0000                                  
            </code>                                                               
                            </pre>
                        </li>
                    </ul>
                </section>

                <section>
                    <ol>
                        <li class="fragment">L'utilisateur demande l'execution du programme 1 <br>1011 0001</li>
                        <li class="fragment">l'OS charge le programme (sur le disque) en mémoire (pile)</li>
                        <li class="fragment">l'OS execute le programme (en mémoire) <br>1000 0001</li>
                        <li class="fragment">le CPU execute la première instruction <br>
                            <pre><code>0101 1010</code></pre></li>
                        <li class="fragment">La carte graphique "dessine" "bonjour"</li>
                        <li class="fragment">le CPU execute la 2ème instruction<br>
                            <pre><code>1010 0000</code></pre></li>
                    </ol>
                </section>

                <section>
                    <h2>Simulons un programme #2</h2>
                    <ul>
                        <li class="fragment">Source: <br>
                            <pre class="code" style="margin: 0; box-shadow: none; overflow-x: hidden;"> <code style="overflow: hidden;">
class Program
{
    static void Main()
    {
        Console.WriteLine("A");
        var a = Console.ReadLine();
        Console.WriteLine("B");
        var b = Console.ReadLine();
        var c = a+b;
        Console.WriteLine(c);
        return 0;
    }                                       
}                              </code>                                 
                            </pre>
                        </li>
                    </ul>
                </section>

                <section>
                    <h2>Simulons un programme #2</h2>
                    <ul>
                        <li class="fragment">Code "machine": <br>
                            <pre class="code csharp" style="margin: 0; box-shadow: none; overflow: hidden;"> <code>
0101 1011 
0111 1011
0101 1100 
0101 1101
0111 1100
1101 1100
1011 1110
0010 1011
0010 1100
0101 1110      
1010 0000
            </code>                                                               
                            </pre>
                        </li>
                    </ul>
                </section>

                <section>
                    <ol>
                        <li class="fragment">L'utilisateur demande l'execution du programme 2 <br>1011 0010</li>
                        <li class="fragment">l'OS charge le programme (sur le disque) en mémoire (pile)</li>
                        <li class="fragment">l'OS execute le programme (en mémoire) <br>1000 0010</li>
                        <li class="fragment">le CPU execute les instructions</li>
                        <li class="fragment">La carte graphique "dessine" le résultat</li>
                        <li class="fragment">le CPU retourne 0 pour dire que tout est OK</li>
                    </ol>
                </section>


                <section>
                    <span style="text-align: left;">Les languages</span>
                    <ul class="fragment">
                        <li><span class="highlight">compilés</span> (C, C++, Delphi, Go, Rust)</li>
                        <li class="fragment">
                            <ul class="linone">
                                <li><span class="highlight">interprétés</span> (Python, Javascript, PHP, Ruby)</li>
                                <li><span class="highlight">semi-interprétés</span> (Java, c#)</li>
                            </ul>
                        </li>
                    </ul>
                </section>

                <section>
                    <table>
                        <tr>
                            <td>Compilés</td>
                            <td>Interprétés</td>
                        </tr>
                        <tr>
                            <td style="vertical-align: top;">
                                <ul class="linone">
                                    <li>Rapidité d'exécution</li>
                                </ul>
                            </td>
                            <td>
                                <ul class="linone">
                                    <li>Flexible</li>
                                    <li>portable</li>
                                    <li>léger</li>
                                </ul>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <ul class="linone">
                                    <li>bcp + de code</li>
                                    <li>bas niveau</li>
                                    <li>complexe à apprendre</li>
                                    <li>depend de la plateforme</li>
                                </ul>
                            </td>
                            <td style="vertical-align: top;">
                                <ul class="linone">
                                    <li>vitesse</li>
                                    <li>protection du code</li>
                                </ul>
                            </td>
                        </tr>
                    </table>
                </section>

                <section>
                    <h3>Quelle forme prennent les programmes ?</h3>
                </section>

                <section>
                    <ul>
                        <li>Scripts</li>
                        <li class="fragment">Programmes console</li>
                        <li class="fragment">Programmes avec IHM <br>
                            <ul>
                                <li>Desktop</li>
                                <li>Mobile</li>
                            </ul>
                        </li>
                        <li class="fragment">Services</li>
                    </ul>
                </section>

                <section>
                    <h3>Et la sécurité ?</h3>
                    <img src="img/CHTML001.gif" alt="" class="fragment">
                    <ul>
                        <li>droits</li>
                        <li>pare-feu</li>
                        <li>malware/backdoor</li>
                    </ul>
                </section>
                <section>
                    <h3>Démos</h3>
                </section>

                <section>
                    <h3>Démo 1 - le script</h3>
                </section>

                <section>
                    <pre><code data-line-numbers="">
@echo off
cls

rem Ceci est une remarque.
:: Ceci est un commentaire.

echo Bonjour les P'tits génies !
echo.
pause
                    </code></pre>
                </section>

                <section>
                    <h3>Démo 2 - le programme console</h3>
                    <div>
                        <pre><code data-trim data-noescape data-line-numbers="1">
C:\Temp> dotnet new console --name Hello
C:\Temp> cd Hello
C:\Temp\Hello> dotnet run
                        </code></pre>
                    </div>
                </section>

                <section>
                    <h3>Démo 3 - le programme avec IHM</h3>
                </section>

                <section>
                    <h3>Démo 4 - le service</h3>
                </section>
            </section>


            <!-- chapter 2 -->
            <section>
                <section>
                    <h2>Decouverte d'utilitaires</h2>
                </section>


                <section>
                    <h2>A vous de jouer</h2>
                </section>

                <section data-markdown>
                    <textarea data-template>
* [AdwCleaner](https://fr.malwarebytes.com/adwcleaner/)
* [VLC](https://www.videolan.org)
* [Foxit PDF Reader](https://www.foxit.com/fr/pdf-reader/)
* [VirtualBox](https://www.virtualbox.org/)
* [Whatsapp](https://www.whatsapp.com/download/)
* [keepass](https://keepass.fr/)
* [ShareX](https://getsharex.com/)
* [Calibre](https://calibre-ebook.com/fr/download)
* [BlueStack](https://www.bluestacks.com/fr/)
* [PowerToys](https://docs.microsoft.com/fr-fr/windows/powertoys/install)
* [SysInternal Suite](https://docs.microsoft.com/en-us/sysinternals/downloads/sysinternals-suite)
* [Spotify](https://www.spotify.com/fr/download/windows/)                        
                    </textarea>
                </section>

                <section data-markdown>
                    <textarea data-template>      

* [PC HealthCheck](https://www.lesnumeriques.com/telecharger/pc-health-check-outil-de-compatibilite-windows-11-50770-40992-telechargement)
* [WHYNOTWIN11](https://www.lesnumeriques.com/telecharger/whynotwin11-50802)
* [TrueCrypt](https://truecrypt.fr/)
* [Rufus](https://rufus.ie/fr/)
* [WinDirStat](https://windirstat.net/)
* [HDGraph](https://www.hdgraph.com/index.php?option=com_content&view=article&id=51&Itemid=56&lang=fr)
* [Recuva](https://www.ccleaner.com/recuva)
* [CCleaner](https://www.ccleaner.com/fr-fr)
* [TESTDISK & PHOTOREC](https://www.lesnumeriques.com/telecharger/testdisk-photorec-20534)
* [HxD Hex Editor](https://www.lesnumeriques.com/telecharger/hxd-hex-editor-20536)
* [VSCode](https://code.visualstudio.com/)
* [Resource Hacker](http://www.angusj.com/resourcehacker/)
                    </textarea>
                </section>
                <section data-markdown>
                    <textarea data-template>      

* [7Zip](https://www.7-zip.org/)
* [HWiNFO](https://www.hwinfo.com/)
* [Tails](https://tails.boum.org/index.fr.html)
* [Win10 Privacy](https://www.w10privacy.de/deutsch-start/download/)
* [LockHunter](https://lockhunter.com/)
* [SuperCopier](https://www.lesnumeriques.com/telecharger/supercopier-20198)
* [Format Factory](https://www.clubic.com/telecharger-fiche223920-formatfactory.html)
* [Team Viewer](https://www.clubic.com/telecharger-fiche434102-teamviewer-portable.html)
* [Putty](https://www.putty.org/)
* [OBS](https://obsproject.com/)
* [Flashbackrecorder Express](https://www.flashbackrecorder.com/express/)
                    </textarea>
                </section>

                <!-- <section data-markdown>
                    <textarea data-template>
                        création d'un nouveau projet console
                        ```properties
                        dotnet new console --name First
                        ```
                        Aller dans le projet
                        ```properties
                        cd First
                        ```
                        Compilation et execution                        
                        ```properties
                        dotnet run
                        ```
                    </textarea>
                </section> 

                <section data-markdown="README.md" data-separator="^\n\n\n" data-separator-vertical="^\n\n" data-separator-notes="^Note:" data-charset="iso-8859-15">
                </section>-->

            </section>

            <!-- Check-out -->
            <section>
                <h3>
                    Des questions ?
                </h3>
            </section>

            <section>
                <h1>Merci</h1>
                <h4>Crédits</h4>
                <p>Photos:</p>
                <ul>
                    <li> unsplash.com</li>
                </ul>
            </section>
        </div>
    </div>

    <script src="../src/caniuse-embed.min.js"></script>
    <script src="../src/reveal.js/lib/js/head.min.js"></script>
    <script src="../src/reveal.js/js/reveal.js"></script>

    <!-- Code steps start -->
    <script src="../src/code-steps/prism.js" data-manual></script>
    <!-- Code steps end -->

    <script type="module" src="../src/custom/script-module.js"></script>
</body>

</html>